#ifndef DATA_CONFIG_H
#define DATA_CONFIG_H TRUE

/*
**  config.h
**
**  (C) Copyright 1998-2003 Rocklyte Systems.
**      All Rights Reserved.
*/

#ifndef MAIN_H
#include <pandora/main.h>
#endif

/*****************************************************************************
** Configuration class.
*/

#define VER_CONFIG 1.0

struct ConfigEntry {
   STRING Section;
   STRING Item;
   STRING Data;
   LONG SectionOffset;
   LONG ItemOffset;
   LONG DataOffset;
};

#define CNF_STRIPQUOTES 0x00000001
#define CNF_AUTOSAVE    0x00000002

/*****************************************************************************
** Config Methods
*/

#define MT_ReadConfig                -1
#define MT_ReadConfigInt             -2
#define MT_WriteConfig               -3
#define MT_DeleteConfigEntry         -4
#define MT_DeleteConfigSection       -5
#define MT_GetConfigSectionFromIndex -6
#define MT_SortConfig                -7
#define MT_ReadConfigFloat           -8
#define MT_MergeConfigFile           -9
#define MT_MergeConfig               -10
#define MT_SetConfig                 -11

#define MT_AddConfigEntry            MT_WriteConfig

struct mtAddConfigEntry {
   STRING Section;
   STRING Item;
   STRING Data;
};

struct mtDeleteConfigEntry {
   LONG Index;
};

struct mtDeleteConfigSection {
   STRING Section;
};

struct mtGetConfigSectionFromIndex {
   LONG Index;
   STRING Result;
};

struct mtMergeConfig {
   OBJECTID ConfigID;
};

struct mtMergeConfigFile {
   STRING Location;
};

struct mtReadConfigFloat {
   STRING Section;
   STRING Item;
   union {
      DOUBLE Float; /* Result */
      DOUBLE Result;
   };
};

struct mtReadConfigInt {
   STRING Section;
   STRING Item;
   union {
      LONG Integer; /* Result */
      LONG Result;
   };
};

struct mtReadConfig {
   STRING Section;
   STRING Item;
   union {
      STRING Data; /* Result */
      STRING Result;
   };
};

struct mtSetConfig {
   STRING Section;
   STRING Item;
   STRING Data;
};

struct mtSortConfig {
   STRING Item;
   LONG Descending;
};

struct mtWriteConfig {
   STRING Section;
   STRING Item;
   STRING Data;
};

#endif /* DATA_CONFIG_H */
